package dev.shadowsoffire.apotheosis.adventure.loot;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.Level;
import net.minecraftforge.event.level.LevelEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.loading.FMLEnvironment;
import net.minecraftforge.server.ServerLifecycleHooks;

@EventBusSubscriber(modid = "apotheosis", bus = Mod.EventBusSubscriber.Bus.FORGE)
class ShieldBreakerTest implements Predicate<ItemStack> {
  private static Map<Level, Zombies> zombieCache = new IdentityHashMap<>();
  
  public boolean test(ItemStack t) {
    try {
      MinecraftServer server = ServerLifecycleHooks.getCurrentServer();
      Level level = null;
      if (server != null) {
        ServerLevel serverLevel = server.m_129880_(Level.f_46428_);
      } else if (FMLEnvironment.dist.isClient()) {
        level = Client.getLevel();
      } 
      if (level != null) {
        Zombies zombies = zombieCache.computeIfAbsent(level, dev.shadowsoffire.apotheosis.adventure.loot.ShieldBreakerTest.Zombies::new);
        return t.canDisableShield(zombies.target.m_21206_(), (LivingEntity)zombies.target, (LivingEntity)zombies.attacker);
      } 
      return t.canDisableShield(Items.f_42740_.m_7968_(), null, null);
    } catch (Exception ex) {
      AdventureModule.LOGGER.error("Failed to execute ShieldBreakerTest", ex);
      return false;
    } 
  }
  
  @SubscribeEvent
  public static void unload(LevelEvent.Unload e) {
    zombieCache.remove(e.getLevel());
  }
}
